#pragma once

#include <Client/Scene.hpp>
#include <JUI/JUI.hpp>
#include <JUI/Widgets/Scene.hpp>
#include <JUI/Widgets/TextRect.hpp>
#include <JUI/Widgets/ScrollingRect.hpp>
#include "JUI/Widgets/Button.hpp"
#include <JUI/Widgets/TextButton.hpp>

namespace CaveGame::Client
{

    struct SingleplayerSessionInfo {
        bool NewWorld;
    };

    class MainMenu : public Scene {
    public:
        Event<SingleplayerSessionInfo> RequestWorld;
        Event<> RequestQuit;
        Event<> RequestShowCredits;
        MainMenu();
        void Update(float elapsed) override;
        void Draw() override;
        void Load() override;
        void Unload() override;

        void BuildWidgets();
        void PassWindowSize(const J3ML::LinearAlgebra::Vector2 &size) override;
        void PassMouseInput(unsigned int, bool) override;
        void PassMouseMovement(const J3ML::LinearAlgebra::Vector2 &pos) override;
    protected:
        JUI::Scene* scene;
        JUI::TextRect* title;
        JUI::Rect* button_group;
        JUI::Rect* changelog;
        JGL::Texture* bg; // TODO: RAII on this
        Vector2 mpos {0,0};
        Vector2 goal {0,0};
    private:
        JUI::TextButton *create_mainmenu_btn(const std::string &content, JUI::Widget *parent);
    };

}