#pragma once

#include <J3ML/LinearAlgebra/Vector2.hpp>
#include "SceneManager.hpp"
#include <rewindow/types/key.h>

namespace CaveGame::Client
{

    class SceneManager;
    class Scene
    {
    public:
        Scene();
        /// @note Make sure to call this base when overriding in derived Scene classes.
        virtual void Load();
        /// @note Make sure to call this base when overriding in derived Scene classes.
        virtual void Unload();
        virtual void Update(float elapsed) = 0;
        virtual void Draw() = 0;
        virtual void PassWindowSize(const Vector2& size);

        virtual void PassMouseInput(unsigned int mouse_btn, bool pressed) {}
        virtual void PassKeyInput(Key key, bool pressed) {}
        virtual void PassMouseMovement(const Vector2& pos) {}
        [[nodiscard]] bool Active() const;
    protected:
        bool active;
        Vector2 window_size;
    private:
    };
}

