
#pragma once

#include <Core/Data.hpp>

namespace CaveGame::Core
{
    using TileState = uint16_t;

    class ITileMap
    {
    public:
        virtual TileID GetTile(int x, int y) const = 0;
        virtual void SetTile(int x, int y, TileID tile) = 0;

        virtual TileState GetTileState(int x, int y) const = 0;
        virtual void SetTileState(int x, int y, TileState state) = 0;

        bool GrassSpreadable(int x, int y) const;

        bool IsNonSolidTile(int x, int y) const;

        bool GrassShouldSuffocate(int x, int y) const;

        void GrassRandomTicc(int wx, int wy);

        bool IsSolidTile(int x, int y) const;

        bool HasAdjacentOrDiagonalAirBlock(int x, int y) const;

        bool HasAdjacentAirBlock(int x, int y) const;
    };
}