#pragma once


#include "Perlin.hpp"

namespace CaveGame::Core
{
    class OctaveNoise {
    public:
        OctaveNoise(int seed) : perlin(seed)
        { }


        double Noise(int octaves, double x, double y, double z)
        {
            double scale = 1.f;
            double value = 0.f;

            for (int i = 0; i < octaves; i++)
            {
                double scaledX = x * scale;
                double scaledY = y * scale;
                double scaledZ = z * scale;

                value += perlin.Noise(scaledX, scaledY, scaledZ) * scale;
                scale /= 2;
            }

            return value;
        }
    protected:
        PerlinNoise perlin;
    private:

    };
}