#include <Core/Tile.hpp>

namespace CaveGame::Core
{
    std::array<Tile*, 65535> registered_tiles{};


    void DefineTiles() {
        RegisterTile(new Tile(TileID::AIR, "air", {0,0,0,0}));
        RegisterTile(new SoilTile(TileID::DIRT, "dirt", Colors::Green, TileID::DIRT));
        RegisterTile(new SoilTile(TileID::MUD, "mud", Colors::Green, TileID::MUD));
        RegisterTile(new Tile(TileID::STONE, "stone", Colors::Green));
        RegisterTile(new GrassyTile(TileID::GRASS, "grass", Colors::Green));

    }

    Tile *GetByName(const std::string &name) {
        // TODO: Optimize with additional mapping!!
        for(auto& tile : registered_tiles)
            if (tile->mnemonic_id == name)
                return tile;

        throw std::runtime_error("Invalid mnemonic ID!");
    }

    Tile *GetByNumeric(TileID id) {
        // TODO: Optimize with additional mapping!!
        //if (registered_tiles.at((uint16_t)id))
            return registered_tiles[(uint16_t)id];
        //for(auto& tile : registered_tiles)
            //if (tile->numeric_id == id)
               //return tile;
        //throw std::runtime_error("ID not in tile registry!");
        return nullptr;
    }

    void RegisterTile(Tile *data) {
        uint16_t index = (uint16_t)data->numeric_id;
        registered_tiles[index] = data;
    }
}